/// @addtogroup interval
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file intervalSetting.h
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

// This file controls the setting in which the krak and/or inerval
// packages are compiled.
// Note that you don't have to modify this file - most settings can be
// selected with the -D argument of your command-line compiler
// or in your project. However, if the auto-detection does not work
// in your case, you may want to modify some specific options.


#ifndef _INTERVAL_SETTING_H_
#define _INTERVAL_SETTING_H_

// This allows automatic detection of operating system and compiler
#include "capd/operatingSystemSetting.h"
#include "capd/compilerSetting.h"


// #################### Settings for the interval package ###################

/* If you wish interval arithmetic with frequent processor switching
   comment out the following #define. */

//#define UP_ROUNDING

/* Comment out the following #define if you do not use the
   KRAK graphics package with the interval package */

//#define KRAK

/* Uncomment the following #define if you want to
   redirect the cerr output to a subwindow.  */

// #define KRAK_ERRORS

/* Uncomment the followng define if you want debugging code added. */

//#define DEBUGGING


#endif // _INTERVAL_SETTING_H_

/// @}
