/// @addtogroup multiEngHom
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file powerTwoCeiling.h
///
/// @author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) Marian Mrozek 2005-2006
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#if !defined(_POWERTWOCEILING_H_)
#define _POWERTWOCEILING_H_
inline int powerTwoCeiling(int n){
  int k=1;
  while(k<n) k=k << 1;
  return k;
}

inline unsigned int baseTwoLog(unsigned long int n){
  int k=0;
  while(n>1){
    n=n >> 1;
    ++k;
  }
  return k;
}
#endif//_POWERTWOCEILING_H_

/// @}

