/// @addtogroup vectalg
/// @{
/////////////////////////////////////////////////////////////////////////////
/// @file intMatrixMD.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#include "vectalg/vector.h"
#include "vectalg/matrix.h"

template class Matrix<int,0,0>;
template class RowVector<int,0>;
template class ColumnVector<int,0>;

template Matrix<int,0,0> abs <int,0,0> (const Matrix<int,0,0>&);
template Matrix<int,0,0> operator- <int,0,0> (const Matrix<int,0,0>&);
template Matrix<int,0,0> operator+ <int,0,0> (const Matrix<int,0,0>&, const Matrix<int,0,0>&);
template Matrix<int,0,0> operator- <int,0,0> (const Matrix<int,0,0>&, const Matrix<int,0,0>&);
template Matrix<int,0,0> operator* <int,0,0> (const Matrix<int,0,0>&, const Matrix<int,0,0>&);
template Vector<int,0> operator* <int,0,0> (const Matrix<int,0,0>&, const Vector<int,0>&);
template Matrix<int,0,0> operator* <int,0,0> (const Matrix<int,0,0>&, const int&);
template Matrix<int,0,0> operator* <int,0,0> (const int&, const Matrix<int,0,0>&);
template Matrix<int,0,0> operator/ <int,0,0> (const Matrix<int,0,0>&, const int&);
template Matrix<int,0,0> operator+ <int,0,0> (const Matrix<int,0,0>&, const int&);
template Matrix<int,0,0> operator- <int,0,0> (const Matrix<int,0,0>&, const int&);
template bool operator< <int,0,0> (const Matrix<int,0,0>&, const Matrix<int,0,0>&);
template bool operator> <int,0,0> (const Matrix<int,0,0>&, const Matrix<int,0,0>&);
template bool operator<= <int,0,0> (const Matrix<int,0,0>&, const Matrix<int,0,0>&);
template bool operator>= <int,0,0> (const Matrix<int,0,0>&, const Matrix<int,0,0>&);
template Matrix<int,0,0> Transpose <int,0,0> (const Matrix<int,0,0>&);
template std::ostream &operator<< <int,0,0> (std::ostream&, const Matrix<int,0,0>&);
template std::istream &operator>> <int,0,0> (std::istream&, Matrix<int,0,0>&);

// RowVector

template Vector<int,0> operator+<int,0>(
      const Vector<int,0>&,
      const RowVector<int,0>&
   );
template Vector<int,0> operator+<int,0>(
      const RowVector<int,0>&,
      const Vector<int,0>&
   );
template Vector<int,0> operator+<int,0>(
      const RowVector<int,0>&,
      const RowVector<int,0>&
   );

template Vector<int,0> operator-<int,0>(
      const Vector<int,0>&,
      const RowVector<int,0>&
   );
template Vector<int,0> operator-<int,0>(
      const RowVector<int,0>&,
      const Vector<int,0>&
   );
template Vector<int,0> operator-<int,0>(
      const RowVector<int,0>&,
      const RowVector<int,0>&
   );

template int operator*<int,0>(
      const Vector<int,0>&,
      const RowVector<int,0>&
   );
template int operator*<int,0>(
      const RowVector<int,0>&,
      const Vector<int,0>&
   );
template int operator*<int,0>(
      const RowVector<int,0>&,
      const RowVector<int,0>&
   );

template Vector<int,0> operator-<int,0>(const RowVector<int,0>&);
template Vector<int,0> operator*<int,0,0>(
      const Matrix<int,0,0>&, const RowVector<int,0>&
   );

template Vector<int,0> operator*<int,0>(const int&, const RowVector<int,0>&);
template Vector<int,0> operator*<int,0>(const RowVector<int,0>&, const int&);
template Vector<int,0> operator/<int,0>(const RowVector<int,0>&, const int&);

template std::ostream& operator<< <int,0>(std::ostream&, const RowVector<int,0>&);


// ColumnVector

template Vector<int,0> operator+<int,0>(
      const Vector<int,0>&,
      const ColumnVector<int,0>&
   );
template Vector<int,0> operator+<int,0>(
      const ColumnVector<int,0>&,
      const Vector<int,0>&
   );
template Vector<int,0> operator+<int,0>(
      const ColumnVector<int,0>&,
      const ColumnVector<int,0>&
   );

template Vector<int,0> operator-<int,0>(
      const Vector<int,0>&,
      const ColumnVector<int,0>&
   );
template Vector<int,0> operator-<int,0>(
      const ColumnVector<int,0>&,
      const Vector<int,0>&
   );
template Vector<int,0> operator-<int,0>(
      const ColumnVector<int,0>&,
      const ColumnVector<int,0>&
   );

template int operator*<int,0>(
      const Vector<int,0>&,
      const ColumnVector<int,0>&
   );
template int operator*<int,0>(
      const ColumnVector<int,0>&,
      const Vector<int,0>&
   );
template int operator*<int,0>(
      const ColumnVector<int,0>&,
      const ColumnVector<int,0>&
   );

template Vector<int,0> operator-<int,0>(const ColumnVector<int,0>&);
template Vector<int,0> operator*<int,0,0>(
      const Matrix<int,0,0>&,
      const ColumnVector<int,0>&
   );

template Vector<int,0> operator*<int,0>(const int&, const ColumnVector<int,0>&);
template Vector<int,0> operator*<int,0>(const ColumnVector<int,0>&, const int&);
template Vector<int,0> operator/<int,0>(const ColumnVector<int,0>&, const int&);

template std::ostream& operator<< <int,0>(std::ostream&, const ColumnVector<int,0>&);


/// @}
